import { Context } from 'skypager-registry'
import Helper from '../helper'

export class Importer extends Helper {
  static isCacheable = true

  static cacheable(setting = true) {
    return this.isCacheable = !!setting
  }

  static createRegistry = () => new Context('importers', {
    context: require.context('../importers', false, /.js$/),
  })

  static attach(project, options = {}) {
    return Helper.attach(project, Importer, {
      registryProp: 'importers',
      lookupProp: 'importer',
      registry: options.registry || Importer.createRegistry(),
      ...options,
    })
  }
}

export default Importer
